-- By Matios95

MAT = {};

function MAT.prerequisitesPresent(specializations)
    return true;
end;

function MAT:load(xmlFile)
	self.index = {};
	self.index.cieglo = Utils.indexToObject(self.components, "0>3|0|0|2|0|1");
	self.wysylanie = SpecializationUtil.callSpecializationsFunction("wysylanie");
	self.animId = getAnimCharacterSet(Utils.indexToObject(self.components, "0>3|0"));
	self.animTor = getAnimClipIndex(self.animId, "Hydropak");
	assignAnimTrackClip(self.animId, 0, self.animTor);
	setAnimTrackLoopState(self.animId, 0, false);
	setAnimTrackSpeedScale(self.animId, 0, 0);
	setAnimTrackTime(self.animId, 0, 0);
	enableAnimTrack(self.animId, 0);
	self.automat = true;
end;

function MAT:delete()
end;

function MAT:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MAT:keyEvent(unicode, sym, modifier, isDown)
end;

function MAT:update(dt)
	if self:getIsActiveForInput() then 
		if self.automat == false then
			if InputBinding.isPressed(InputBinding.KeyPageUp) then
				self:wysylanie(self.automat, 1);
			elseif InputBinding.isPressed(InputBinding.KeyPageDown) then
				self:wysylanie(self.automat, -1); 
			elseif not InputBinding.isPressed(InputBinding.KeyPageDown) and not InputBinding.isPressed(InputBinding.KeyPageUp) then
				self:wysylanie(self.automat, 0);
			end;
		end;
		if InputBinding.hasEvent(InputBinding.Key9) then
			self:wysylanie(not self.automat, 0);
		end;
	end;
	if self.automat == true then
		if self.cultivatorHasGroundContact == true then
			if getAnimTrackTime(self.animId, 0) > 0 then
				setAnimTrackSpeedScale(self.animId, 0, -2);
			else
				setAnimTrackSpeedScale(self.animId, 0, 0);
			end;
		else
			if getAnimTrackTime(self.animId, 0) < 5000 then
				setAnimTrackSpeedScale(self.animId, 0, 1);
			else
				setAnimTrackSpeedScale(self.animId, 0, 0);
			end;
		end;
	end;
end;

function MAT:draw()
	if self.automat == false then
		g_currentMission:addHelpButtonText("Wlacz Automatyczny Hydropak", InputBinding.Key9);
		g_currentMission:addHelpButtonText("Podenies Hydropak", InputBinding.KeyPageUp);
		g_currentMission:addHelpButtonText("Opusc Hydropak", InputBinding.KeyPageDown);
	else
		g_currentMission:addHelpButtonText("Wylacz Automatyczny Hydropak", InputBinding.Key9);
	end;
end;

function MAT:wysylanie(automat, skala, opcja)
	self.automat = automat;
	if automat == false then
		if skala == 1 then
			if getAnimTrackTime(self.animId, 0) < 5000 then
				setAnimTrackSpeedScale(self.animId, 0, 1);
			else
				setAnimTrackSpeedScale(self.animId, 0, 0);
			end;
		elseif skala == -1 then
			if getAnimTrackTime(self.animId, 0) > 0 then
				setAnimTrackSpeedScale(self.animId, 0, -1);
			else
				setAnimTrackSpeedScale(self.animId, 0, 0);
			end;
		else
			setAnimTrackSpeedScale(self.animId, 0, 0);
		end;
	end;
	if opcja ~= true then
		MATEvent.sendEvent(self, automat, skala);
	end;
end;

function MAT:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;





MAT2 = {};

function MAT2.prerequisitesPresent(specializations)
    return true;
end;

function MAT2:load(xmlFile)
	self.index = {};
	self.index.klapa = Utils.indexToObject(self.components, "0>3|0");
	self.wysylanie = SpecializationUtil.callSpecializationsFunction("wysylanie");
	self.animId = getAnimCharacterSet(Utils.indexToObject(self.components, "0>3|0"));
	self.animTor = getAnimClipIndex(self.animId, "Klapa");
	assignAnimTrackClip(self.animId, 0, self.animTor);
	setAnimTrackLoopState(self.animId, 0, false);
	setAnimTrackSpeedScale(self.animId, 0, 0);
	setAnimTrackTime(self.animId, 0, 0);
	enableAnimTrack(self.animId, 0);
end;

function MAT2:delete()
end;

function MAT2:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MAT2:keyEvent(unicode, sym, modifier, isDown)
end;

function MAT2:update(dt)
	local vx1, vy1, vz1 = getWorldTranslation(g_currentMission.player.rootNode); 
	local vx2, vy2, vz2 = getWorldTranslation(self.index.klapa); 
	
	local dystans1 = Utils.vector3Length(vx2-vx1, vy2-vy1, vz2-vz1);	
	
	if dystans1 < 3 then 
		if self.stan == true then
			g_currentMission:addHelpButtonText("Zamknij klape w siewniku", InputBinding.KeyX);
			if InputBinding.hasEvent(InputBinding.KeyX) then
				self:wysylanie(false, false);
			end;
		else
			g_currentMission:addHelpButtonText("Otworz klape w siewniku", InputBinding.KeyX);
			if InputBinding.hasEvent(InputBinding.KeyX) then
				self:wysylanie(true, false);
			end;
		end;
	end;
	
	if self.stan == true then
		if getAnimTrackTime(self.animId, 0) < getAnimClipDuration(self.animId, 0) then
			setAnimTrackSpeedScale(self.animId, 0, 1);
		else
			setAnimTrackSpeedScale(self.animId, 0, 0);
		end;
	else
		if getAnimTrackTime(self.animId, 0) > 0 then
			setAnimTrackSpeedScale(self.animId, 0, -1);
		else
			setAnimTrackSpeedScale(self.animId, 0, 0);
		end;
	end;
end;

function MAT2:draw()
end;

function MAT2:wysylanie(stan, opcja)
	self.stan = stan;
	
	if opcja ~= true then
		MATEvent2.sendEvent(self, stan);
	end;
end;

function MAT2:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;



MATEvent = {};
MATEvent_mt = Class(MATEvent, Event);

InitEventClass(MATEvent, "MATEvent");

function MATEvent:emptyNew()
    local self = Event:new(MATEvent_mt);
    self.className="MATEvent";
    return self;
end;

function MATEvent:new(object, auto, skala)
    local self = MATEvent:emptyNew()
    self.object = object;
	self.skala = skala;
	self.auto = auto;
    return self;
end;

function MATEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.skala = streamReadInt8(streamId);
	self.auto = streamReadBool(streamId);
	self.object:wysylanie(self.auto, self.skala, true);
	
    if not connection:getIsServer() then
        g_server:broadcastEvent(MATEvent:new(self.object, self.auto, self.skala), nil, connection, self.object);
    end;
end;

function MATEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteInt8(streamId, self.skala);
	streamWriteBool(streamId, self.auto);
end;

function MATEvent.sendEvent(vehicle, auto, skala)
	if g_server ~= nil then
		g_server:broadcastEvent(MATEvent:new(vehicle, auto, skala), nil, nil, vehicle);
	else
		g_client:getServerConnection():sendEvent(MATEvent:new(vehicle, auto, skala));
	end;
end;


MATEvent2 = {};
MATEvent2_mt = Class(MATEvent2, Event);


InitEventClass(MATEvent2, "MATEvent2");


function MATEvent2:emptyNew()
    local self = Event:new(MATEvent2_mt);
    self.className="MATEvent2";
    return self;
end;


function MATEvent2:new(object, stan)
    local self = MATEvent2:emptyNew()
    self.object = object;
	self.stan = stan;
    return self;
end;


function MATEvent2:readStream(streamId, connection)
	self.object = networkGetObject(streamReadInt32(streamId));
	self.stan = streamReadBool(streamId);
	self.object:wysylanie(self.stan, true);
	
    if not connection:getIsServer() then
        g_server:broadcastEvent(MATEvent2:new(self.object, self.stan), nil, connection, self.object);
    end;
end;


function MATEvent2:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.stan);
end;


function MATEvent2.sendEvent(vehicle, stan)
	if g_server ~= nil then
		g_server:broadcastEvent(MATEvent2:new(vehicle, stan), nil, nil, vehicle);
	else
		g_client:getServerConnection():sendEvent(MATEvent2:new(vehicle, stan));
	end;
end;